#ifndef _STDIO_FP11_
#define _STDIO_FP11_

#define C_SCREEN_0 0x00
#define C_SCREEN_1 0x01
#define C_SCREEN_2 0x02
#define C_SCREEN_3 0x03
#define C_SCREEN_4 0x04
#define C_SCREEN_5 0x05
#define C_SCREEN_6 0x06
#define C_SCREEN_7 0x07
#define C_SCREEN_11 0x0B

#define C_DFU_OP_VVER 0x00
#define C_DFU_OP_VZ2A 0x01
#define C_DFU_OP_VB2A 0x02
#define C_DFU_OP_VZ2B 0x03
#define C_DFU_OP_VA2B 0x04
#define C_DFU_OP_VADD 0x05
#define C_DFU_OP_VADD_BZ2A 0x06
#define C_DFU_OP_VADD_AZ2B 0x07
#define C_DFU_OP_VSUB 0x08
#define C_DFU_OP_VSUB_BZ2A 0x09
#define C_DFU_OP_VSUB_AZ2B 0x0A
#define C_DFU_OP_VMULT 0x0B
#define C_DFU_OP_VMULT_BZ2A 0x0C
#define C_DFU_OP_VMULT_AZ2B 0x0D
#define C_DFU_OP_VPROD 0x0E
#define C_DFU_OP_VMAC 0x0F
#define C_DFU_OP_VMSUBAC 0x10

#define C_DFU_A_MEM_BANK 0x00
#define C_DFU_A_MEM_ADDR 0x02
#define C_DFU_A_INC 0x04
#define C_DFU_B_MEM_BANK 0x06
#define C_DFU_B_MEM_ADDR 0x07
#define C_DFU_B_INC 0x0A
#define C_DFU_Z_MEM_BANK 0x0B
#define C_DFU_Z_MEM_ADDR 0x0C
#define C_DFU_Z_INC 0x0E
#define C_DFU_CNT 0x0F
#define C_DFU_OP 0x05
#define C_DFU_A_MEM_SADDR 0x03
#define C_DFU_B_MEM_SADDR 0x09
#define C_DFU_Z_MEM_SADDR 0x0D

#define C_MB2PB_REG_STAT 0x00
#define C_PB2MB_REG_CTRL 0x00
#define C_PB2MB_MODE_BYTE 0x01
#define C_PB2MB_MODE_EOL 0x03
#define C_PB2MB_MODE_REQ 0x07
#define C_PB2MB_MODE_RESET 0x08

#define C_PBP_REG01 0x01
#define C_PBP_REG02 0x02
#define C_PBP_REG04 0x04
#define C_PBP_REG05 0x05
#define C_PBP_REG08 0x08

#define C_MB2PB_FL_ZEROB 0x00
#define C_MB2PB_FL_BYTEB 0x01
#define C_PB2MB_FL_NONE 0x00
#define C_PB2MB_FL_BYTE 0x01
#define C_PB2MB_FL_EOL 0x02
#define C_PB2MB_FL_RREQ 0x04
#define C_PB2MB_FL_RESET 0x08
#define C_PB2MB_FL_B_E 0x03
#define C_PB2MB_FL_B_E_R 0x07

#define C_LCD_00 0x20
#define C_LCD_01 0x21
#define C_LCD_02 0x22
#define C_LCD_03 0x23
#define C_LCD_04 0x24
#define C_LCD_05 0x25
#define C_LCD_06 0x26
#define C_LCD_07 0x27
#define C_LCD_08 0x28
#define C_LCD_09 0x29
#define C_LCD_0A 0x2A
#define C_LCD_0B 0x2B
#define C_LCD_0C 0x2C
#define C_LCD_0D 0x2D
#define C_LCD_0E 0x2E
#define C_LCD_0F 0x2F
#define C_LCD_10 0x30
#define C_LCD_11 0x31
#define C_LCD_12 0x32
#define C_LCD_13 0x33
#define C_LCD_14 0x34
#define C_LCD_15 0x35
#define C_LCD_16 0x36
#define C_LCD_17 0x37
#define C_LCD_18 0x38
#define C_LCD_19 0x39
#define C_LCD_1A 0x3A
#define C_LCD_1B 0x3B
#define C_LCD_1C 0x3C
#define C_LCD_1D 0x3D
#define C_LCD_1E 0x3E
#define C_LCD_1F 0x3F

#define C_INP_MASK_0F 0x0F
#define C_INP_MASK_F0 0xF0

#define C_CH_a 0x61
#define C_CH_b 0x62
#define C_CH_c 0x63
#define C_CH_d 0x64
#define C_CH_e 0x65
#define C_CH_f 0x66
#define C_CH_g 0x67
#define C_CH_h 0x68
#define C_CH_i 0x69
#define C_CH_j 0x6A
#define C_CH_k 0x6B
#define C_CH_l 0x6C
#define C_CH_m 0x6D
#define C_CH_n 0x6E
#define C_CH_o 0x6F
#define C_CH_p 0x70
#define C_CH_q 0x71
#define C_CH_r 0x72
#define C_CH_s 0x73
#define C_CH_t 0x74
#define C_CH_u 0x75
#define C_CH_v 0x76
#define C_CH_w 0x77
#define C_CH_x 0x78
#define C_CH_y 0x79
#define C_CH_z 0x7A
#define C_CH_A 0x41
#define C_CH_B 0x42
#define C_CH_C 0x43
#define C_CH_D 0x44
#define C_CH_E 0x45
#define C_CH_F 0x46
#define C_CH_G 0x47
#define C_CH_H 0x48
#define C_CH_I 0x49
#define C_CH_J 0x4A
#define C_CH_K 0x4B
#define C_CH_L 0x4C
#define C_CH_M 0x4D
#define C_CH_N 0x4E
#define C_CH_O 0x4F
#define C_CH_P 0x50
#define C_CH_Q 0x51
#define C_CH_R 0x52
#define C_CH_S 0x53
#define C_CH_T 0x54
#define C_CH_U 0x55
#define C_CH_V 0x56
#define C_CH_W 0x57
#define C_CH_X 0x58
#define C_CH_Y 0x59
#define C_CH_Z 0x5A
#define C_CH_0 0x30
#define C_CH_1 0x31
#define C_CH_2 0x32
#define C_CH_3 0x33
#define C_CH_4 0x34
#define C_CH_5 0x35
#define C_CH_6 0x36
#define C_CH_7 0x37
#define C_CH_8 0x38
#define C_CH_9 0x39
#define C_CH_colon 0x3A
#define C_CH_fullstop 0x2E
#define C_CH_semi_colon 0x3B
#define C_CH_minus 0x2D
#define C_CH_plus 0x2B
#define C_CH_comma 0x2C
#define C_CH_less_than 0x3C
#define C_CH_greater_than 0x3E
#define C_CH_open 0x28
#define C_CH_close 0x29
#define C_CH_divide 0x2F
#define C_CH_equals 0x3D
#define C_CH_space 0x20
#define C_CH_CR 0x0D
#define C_CH_LF 0x0A
#define C_CH_question 0x3F
#define C_CH_dollar 0x24
#define C_CH_exclaim 0x21
#define C_CH_BS 0x08

#define SCREEN_0 00
#define SCREEN_1 01
#define SCREEN_2 02
#define SCREEN_3 03
#define SCREEN_4 04
#define SCREEN_5 05
#define SCREEN_6 06
#define SCREEN_7 07
#define SCREEN_11 0B

#define DFU_OP_VVER 00
#define DFU_OP_VZ2A 01
#define DFU_OP_VB2A 02
#define DFU_OP_VZ2B 03
#define DFU_OP_VA2B 04
#define DFU_OP_VADD 05
#define DFU_OP_VADD_BZ2A 06
#define DFU_OP_VADD_AZ2B 07
#define DFU_OP_VSUB 08
#define DFU_OP_VSUB_BZ2A 09
#define DFU_OP_VSUB_AZ2B 0A
#define DFU_OP_VMULT 0B
#define DFU_OP_VMULT_BZ2A 0C
#define DFU_OP_VMULT_AZ2B 0D
#define DFU_OP_VPROD 0E
#define DFU_OP_VMAC 0F
#define DFU_OP_VMSUBAC 10

#define DFU_A_MEM_BANK 00
#define DFU_A_MEM_ADDR 02
#define DFU_A_INC 04
#define DFU_B_MEM_BANK 06
#define DFU_B_MEM_ADDR 07
#define DFU_B_INC 0A
#define DFU_Z_MEM_BANK 0B
#define DFU_Z_MEM_ADDR 0C
#define DFU_Z_INC 0E
#define DFU_CNT 0F
#define DFU_OP 05
#define DFU_A_MEM_SADDR 03
#define DFU_B_MEM_SADDR 09
#define DFU_Z_MEM_SADDR 0D

#define MB2PB_REG_STAT 00
#define PB2MB_REG_CTRL 00
#define PB2MB_MODE_BYTE 01
#define PB2MB_MODE_EOL 03
#define PB2MB_MODE_REQ 07
#define PB2MB_MODE_RESET 08

#define PBP_REG01 01
#define PBP_REG02 02
#define PBP_REG04 04
#define PBP_REG05 05
#define PBP_REG08 08

#define MB2PB_FL_ZEROB 00
#define MB2PB_FL_BYTEB 01
#define PB2MB_FL_NONE 00
#define PB2MB_FL_BYTE 01
#define PB2MB_FL_EOL 02
#define PB2MB_FL_RREQ 04
#define PB2MB_FL_RESET 08
#define PB2MB_FL_B_E 03
#define PB2MB_FL_B_E_R 07

#define LCD_00 20
#define LCD_01 21
#define LCD_02 22
#define LCD_03 23
#define LCD_04 24
#define LCD_05 25
#define LCD_06 26
#define LCD_07 27
#define LCD_08 28
#define LCD_09 29
#define LCD_0A 2A
#define LCD_0B 2B
#define LCD_0C 2C
#define LCD_0D 2D
#define LCD_0E 2E
#define LCD_0F 2F
#define LCD_10 30
#define LCD_11 31
#define LCD_12 32
#define LCD_13 33
#define LCD_14 34
#define LCD_15 35
#define LCD_16 36
#define LCD_17 37
#define LCD_18 38
#define LCD_19 39
#define LCD_1A 3A
#define LCD_1B 3B
#define LCD_1C 3C
#define LCD_1D 3D
#define LCD_1E 3E
#define LCD_1F 3F

#define INP_MASK_0F 0F
#define INP_MASK_F0 F0

#define CH_a 61
#define CH_b 62
#define CH_c 63
#define CH_d 64
#define CH_e 65
#define CH_f 66
#define CH_g 67
#define CH_h 68
#define CH_i 69
#define CH_j 6A
#define CH_k 6B
#define CH_l 6C
#define CH_m 6D
#define CH_n 6E
#define CH_o 6F
#define CH_p 70
#define CH_q 71
#define CH_r 72
#define CH_s 73
#define CH_t 74
#define CH_u 75
#define CH_v 76
#define CH_w 77
#define CH_x 78
#define CH_y 79
#define CH_z 7A
#define CH_A 41
#define CH_B 42
#define CH_C 43
#define CH_D 44
#define CH_E 45
#define CH_F 46
#define CH_G 47
#define CH_H 48
#define CH_I 49
#define CH_J 4A
#define CH_K 4B
#define CH_L 4C
#define CH_M 4D
#define CH_N 4E
#define CH_O 4F
#define CH_P 50
#define CH_Q 51
#define CH_R 52
#define CH_S 53
#define CH_T 54
#define CH_U 55
#define CH_V 56
#define CH_W 57
#define CH_X 58
#define CH_Y 59
#define CH_Z 5A
#define CH_0 30
#define CH_1 31
#define CH_2 32
#define CH_3 33
#define CH_4 34
#define CH_5 35
#define CH_6 36
#define CH_7 37
#define CH_8 38
#define CH_9 39
#define CH_colon 3A
#define CH_fullstop 2E
#define CH_semi_colon 3B
#define CH_minus 2D
#define CH_plus 2B
#define CH_comma 2C
#define CH_less_than 3C
#define CH_greater_than 3E
#define CH_open 28
#define CH_close 29
#define CH_divide 2F
#define CH_equals 3D
#define CH_space 20
#define CH_CR 0D
#define CH_LF 0A
#define CH_question 3F
#define CH_dollar 24
#define CH_exclaim 21
#define CH_BS 08

unsigned char led2pb();
unsigned char btn2pb();
unsigned char mb2pb_read_data();
unsigned char hex_h(unsigned char ch);
unsigned char hex_l(unsigned char ch);
void pb2lcd_ascii_char(unsigned char ch, unsigned char pos);
void pb2dfu_wait4hw();
void pb2mb_write(unsigned char data);
void pb2mb_eoc(unsigned char data);
void pb2mb_req_reset(unsigned char data);
void pb2mb_reset();
void pb2dfu_set(unsigned char mem, unsigned char data);

#asm
;//================================================
;//Fragment function_exit:
_function_exit:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
;//================================================
;//Function led2pb:
_led2pb:
JUMP main_end
JUMP main_end
;//================================================
;//Function btn2pb:
_btn2pb:
JUMP main_end
JUMP main_end
;//================================================
;//Function mb2pb_read_data:
_mb2pb_read_data:
JUMP main_end
JUMP main_end
_mb2pb_read_data0:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
_mb2pb_read_data1:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
;//================================================
;//Function hex_h:
_hex_h:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
_hex_h0:
JUMP main_end
JUMP main_end
JUMP main_end
_hex_h1:
JUMP main_end
JUMP main_end
;//================================================
;//Function hex_l:
_hex_l:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
;//================================================
;//Function pb2lcd_ascii_char:
_pb2lcd_ascii_char:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
;//================================================
;//Function pb2dfu_wait4hw:
_pb2dfu_wait4hw:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
;//================================================
;//Function pb2mb_write:
_pb2mb_write:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
_pb2mb_write0:
JUMP main_end
_pb2mb_write1:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
_pb2mb_write2:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
;//================================================
;//Function pb2mb_eoc:
_pb2mb_eoc:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
;//================================================
;//Function pb2mb_req_reset:
_pb2mb_req_reset:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
;//================================================
;//Function pb2mb_reset:
_pb2mb_reset:
JUMP main_end
JUMP main_end
JUMP main_end
;//================================================
;//Function pb2dfu_set:
_pb2dfu_set:
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
JUMP main_end
#endasm

#endif /* _STDIO_FP11_ */
