///////////////////////////////////////////////////////////////-*-C-*-
//
// Copyright (c) 2011 Xilinx, Inc.  All rights reserved.
//
// Xilinx, Inc.  XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION
// "AS IS" AS  A COURTESY TO YOU.  BY PROVIDING  THIS DESIGN, CODE, OR
// INFORMATION  AS  ONE   POSSIBLE  IMPLEMENTATION  OF  THIS  FEATURE,
// APPLICATION OR  STANDARD, XILINX  IS MAKING NO  REPRESENTATION THAT
// THIS IMPLEMENTATION  IS FREE FROM  ANY CLAIMS OF  INFRINGEMENT, AND
// YOU ARE  RESPONSIBLE FOR OBTAINING  ANY RIGHTS YOU MAY  REQUIRE FOR
// YOUR  IMPLEMENTATION.   XILINX  EXPRESSLY  DISCLAIMS  ANY  WARRANTY
// WHATSOEVER  WITH RESPECT  TO  THE ADEQUACY  OF THE  IMPLEMENTATION,
// INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR REPRESENTATIONS THAT
// THIS IMPLEMENTATION  IS FREE  FROM CLAIMS OF  INFRINGEMENT, IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// 
//////////////////////////////////////////////////////////////////////

#ifndef __XL_BCE_FP11_1X8_0_AXIW_H__
#define __XL_BCE_FP11_1X8_0_AXIW_H__

#include "xbasic_types.h"
#include "xstatus.h"
#include "xcope.h"

typedef struct {
    uint32_t version;
    // Pointers to low-level functions
    xc_status_t (*xc_create)(xc_iface_t **, void *);
    xc_status_t (*xc_release)(xc_iface_t **);
    xc_status_t (*xc_open)(xc_iface_t *);
    xc_status_t (*xc_close)(xc_iface_t *);
    xc_status_t (*xc_read)(xc_iface_t *, xc_r_addr_t, uint32_t *);
    xc_status_t (*xc_write)(xc_iface_t *, xc_w_addr_t, const uint32_t);
    xc_status_t (*xc_get_shmem)(xc_iface_t *, const char *, void **shmem);
    // Optional parameters
    // (empty)
    // Memory map information
    uint32_t z8;
    // uint32_t z8_grant;
    // uint32_t z8_req;
    uint32_t z8_n_bits;
    uint32_t z8_bin_pt;
    uint32_t z8_depth;
    // uint32_t z8_attr;
    uint32_t b8;
    // uint32_t b8_grant;
    // uint32_t b8_req;
    uint32_t b8_n_bits;
    uint32_t b8_bin_pt;
    uint32_t b8_depth;
    // uint32_t b8_attr;
    uint32_t a8;
    // uint32_t a8_grant;
    // uint32_t a8_req;
    uint32_t a8_n_bits;
    uint32_t a8_bin_pt;
    uint32_t a8_depth;
    // uint32_t a8_attr;
    uint32_t z7;
    // uint32_t z7_grant;
    // uint32_t z7_req;
    uint32_t z7_n_bits;
    uint32_t z7_bin_pt;
    uint32_t z7_depth;
    // uint32_t z7_attr;
    uint32_t b7;
    // uint32_t b7_grant;
    // uint32_t b7_req;
    uint32_t b7_n_bits;
    uint32_t b7_bin_pt;
    uint32_t b7_depth;
    // uint32_t b7_attr;
    uint32_t a7;
    // uint32_t a7_grant;
    // uint32_t a7_req;
    uint32_t a7_n_bits;
    uint32_t a7_bin_pt;
    uint32_t a7_depth;
    // uint32_t a7_attr;
    uint32_t z6;
    // uint32_t z6_grant;
    // uint32_t z6_req;
    uint32_t z6_n_bits;
    uint32_t z6_bin_pt;
    uint32_t z6_depth;
    // uint32_t z6_attr;
    uint32_t b6;
    // uint32_t b6_grant;
    // uint32_t b6_req;
    uint32_t b6_n_bits;
    uint32_t b6_bin_pt;
    uint32_t b6_depth;
    // uint32_t b6_attr;
    uint32_t a6;
    // uint32_t a6_grant;
    // uint32_t a6_req;
    uint32_t a6_n_bits;
    uint32_t a6_bin_pt;
    uint32_t a6_depth;
    // uint32_t a6_attr;
    uint32_t z5;
    // uint32_t z5_grant;
    // uint32_t z5_req;
    uint32_t z5_n_bits;
    uint32_t z5_bin_pt;
    uint32_t z5_depth;
    // uint32_t z5_attr;
    uint32_t b5;
    // uint32_t b5_grant;
    // uint32_t b5_req;
    uint32_t b5_n_bits;
    uint32_t b5_bin_pt;
    uint32_t b5_depth;
    // uint32_t b5_attr;
    uint32_t a5;
    // uint32_t a5_grant;
    // uint32_t a5_req;
    uint32_t a5_n_bits;
    uint32_t a5_bin_pt;
    uint32_t a5_depth;
    // uint32_t a5_attr;
    uint32_t z4;
    // uint32_t z4_grant;
    // uint32_t z4_req;
    uint32_t z4_n_bits;
    uint32_t z4_bin_pt;
    uint32_t z4_depth;
    // uint32_t z4_attr;
    uint32_t b4;
    // uint32_t b4_grant;
    // uint32_t b4_req;
    uint32_t b4_n_bits;
    uint32_t b4_bin_pt;
    uint32_t b4_depth;
    // uint32_t b4_attr;
    uint32_t a4;
    // uint32_t a4_grant;
    // uint32_t a4_req;
    uint32_t a4_n_bits;
    uint32_t a4_bin_pt;
    uint32_t a4_depth;
    // uint32_t a4_attr;
    uint32_t z3;
    // uint32_t z3_grant;
    // uint32_t z3_req;
    uint32_t z3_n_bits;
    uint32_t z3_bin_pt;
    uint32_t z3_depth;
    // uint32_t z3_attr;
    uint32_t b3;
    // uint32_t b3_grant;
    // uint32_t b3_req;
    uint32_t b3_n_bits;
    uint32_t b3_bin_pt;
    uint32_t b3_depth;
    // uint32_t b3_attr;
    uint32_t a3;
    // uint32_t a3_grant;
    // uint32_t a3_req;
    uint32_t a3_n_bits;
    uint32_t a3_bin_pt;
    uint32_t a3_depth;
    // uint32_t a3_attr;
    uint32_t z2;
    // uint32_t z2_grant;
    // uint32_t z2_req;
    uint32_t z2_n_bits;
    uint32_t z2_bin_pt;
    uint32_t z2_depth;
    // uint32_t z2_attr;
    uint32_t b2;
    // uint32_t b2_grant;
    // uint32_t b2_req;
    uint32_t b2_n_bits;
    uint32_t b2_bin_pt;
    uint32_t b2_depth;
    // uint32_t b2_attr;
    uint32_t a2;
    // uint32_t a2_grant;
    // uint32_t a2_req;
    uint32_t a2_n_bits;
    uint32_t a2_bin_pt;
    uint32_t a2_depth;
    // uint32_t a2_attr;
    uint32_t z1;
    // uint32_t z1_grant;
    // uint32_t z1_req;
    uint32_t z1_n_bits;
    uint32_t z1_bin_pt;
    uint32_t z1_depth;
    // uint32_t z1_attr;
    uint32_t b1;
    // uint32_t b1_grant;
    // uint32_t b1_req;
    uint32_t b1_n_bits;
    uint32_t b1_bin_pt;
    uint32_t b1_depth;
    // uint32_t b1_attr;
    uint32_t a1;
    // uint32_t a1_grant;
    // uint32_t a1_req;
    uint32_t a1_n_bits;
    uint32_t a1_bin_pt;
    uint32_t a1_depth;
    // uint32_t a1_attr;
    uint32_t pb2mb;
    // uint32_t pb2mb_grant;
    // uint32_t pb2mb_req;
    uint32_t pb2mb_n_bits;
    uint32_t pb2mb_bin_pt;
    uint32_t pb2mb_depth;
    // uint32_t pb2mb_attr;
    uint32_t p1;
    // uint32_t p1_grant;
    // uint32_t p1_req;
    uint32_t p1_n_bits;
    uint32_t p1_bin_pt;
    uint32_t p1_depth;
    // uint32_t p1_attr;
    uint32_t p0;
    // uint32_t p0_grant;
    // uint32_t p0_req;
    uint32_t p0_n_bits;
    uint32_t p0_bin_pt;
    uint32_t p0_depth;
    // uint32_t p0_attr;
    uint32_t mb2pb;
    // uint32_t mb2pb_grant;
    // uint32_t mb2pb_req;
    uint32_t mb2pb_n_bits;
    uint32_t mb2pb_bin_pt;
    uint32_t mb2pb_depth;
    // uint32_t mb2pb_attr;
    // XPS parameters
    Xuint16  DeviceId;
    uint32_t  BaseAddr;
} BCE_FP11_1X8_0_AXIW_Config;

extern BCE_FP11_1X8_0_AXIW_Config BCE_FP11_1X8_0_AXIW_ConfigTable[];

// forward declaration of low-level functions
xc_status_t xc_bce_fp11_1x8_0_axiw_create(xc_iface_t **iface, void *config_table);
xc_status_t xc_bce_fp11_1x8_0_axiw_release(xc_iface_t **iface) ;
xc_status_t xc_bce_fp11_1x8_0_axiw_open(xc_iface_t *iface);
xc_status_t xc_bce_fp11_1x8_0_axiw_close(xc_iface_t *iface);
xc_status_t xc_bce_fp11_1x8_0_axiw_read(xc_iface_t *iface, xc_r_addr_t addr, uint32_t *value);
xc_status_t xc_bce_fp11_1x8_0_axiw_write(xc_iface_t *iface, xc_w_addr_t addr, const uint32_t value);
xc_status_t xc_bce_fp11_1x8_0_axiw_getshmem(xc_iface_t *iface, const char *name, void **shmem);

#endif

